@echo off
TITLE DML WAD Creator
COLOR 0A
echo DIOS-MIOS Lite WAD Creator v0.6 by FIX94
echo.
echo Checking files...
if not exist DML.elf (echo DML.elf not found! & set MissingFiles=1)
if not exist wadmii.exe (echo wadmii.exe not found! & set MissingFiles=1)
if not exist nusd.exe (echo nusd.exe not found! & set MissingFiles=1)
if not exist libWiiSharp.dll (echo libWiiSharp.dll not found! & set MissingFiles=1)
if not exist md5.exe (echo md5.exe not found! & set MissingFiles=1)
if not exist FixELF\FixELF.exe (echo FixELF\FixELF.exe not found! & set MissingFiles=1)
if defined MissingFiles (goto FileNotFound)
echo All files found.
echo.

for %%A in ("%~dp0.") do set name=%%~nA

if exist RVL-mios-v10.wad (
md5 -c851C27DAE82BC1C758BE07FA964D17CB RVL-mios-v10.wad
if errorlevel 1 goto BadWad
) else goto NUSD
goto createwad

:NUSD
echo Downloading MIOS, please wait...
nusd 0000000100000101 10 packwad
move 0000000100000101\0000000100000101.wad RVL-mios-v10.wad
rmdir 0000000100000101 /s /q
echo.
md5 -c851C27DAE82BC1C758BE07FA964D17CB RVL-mios-v10.wad
if errorlevel 1 goto BadWad

:createwad
echo Creating DML WAD, please wait...
wadmii -in RVL-mios-v10.wad -out mios-v10
FixELF\FixELF.exe mios-v10\00000001.app DML.elf mios-v10\0000001.app
del mios-v10\00000001.app
rename mios-v10\0000001.app 00000001.app

Set _dummy=%name:DMLr=%
IF NOT "%_dummy%" == "%name%" (goto RevDefined)
:: The folder does not have DMLr in the name, so we have to ask the revision
echo What revision are you building?
set /p revision="Revision: "
set name=DMLr%revision%

:RevDefined
wadmii -in mios-v10 -out "%name%[MIOS-v10].wad"
rmdir mios-v10 /s /q
goto Finish

:BadWad
COLOR 0C
echo Your RVL-mios-v10.wad is bad. The file will be deleted.
echo Please run the Creator again to re-download it.
DEL RVL-mios-v10.wad
goto eof

:FileNotFound
COLOR 0C
echo.
echo Make sure all files of the WAD Creator package and the
echo DML package are extracted properly to this folder.
goto eof

:Finish
echo.
echo DML has been successfully created.
echo Install %name%[MIOS-v10].wad with a wad manager.

:eof
echo.
pause
